searchNodes=[{"doc":"","ref":"Spike.LiveView.html","title":"Spike.LiveView","type":"module"},{"doc":"","ref":"Spike.LiveView.html#handle_event/3","title":"Spike.LiveView.handle_event/3","type":"function"},{"doc":"Provides low-level components that can be useful to built higher-level form input components in your app. For starting point to build your own form components, see our Components Library .","ref":"Spike.LiveView.Components.html","title":"Spike.LiveView.Components","type":"module"},{"doc":"Allows you to get a map of errors on dirty fields of given form. Attributes: form - required, should map to Spike.Form , usually @form in assigns field - required, atom, should be one of the existing fields on the form dirty_fields -&gt; optional, defautls to Spike.dirty_fields(form) import Spike.LiveView.Components ... &lt; . errors let = { field_errors } field = { @field } form = { @form } errors = { @errors } &gt; &lt; span class = &quot;error&quot; &gt; &lt; % = field_errors |&gt; Enum . map ( fn { _k , v } -&gt; v end ) |&gt; Enum . join ( &quot;, &quot; ) % &gt; &lt; / span &gt; &lt; / . errors &gt;","ref":"Spike.LiveView.Components.html#errors/1","title":"Spike.LiveView.Components.errors/1","type":"function"},{"doc":"Renders form, which wraps input fields, allowing for Spike.LiveView events to be emitted on change, and captured by LiveView or LiveComponent specified by target attribute. This component accepts a slot, in which your input field should reside along with any additional markup you may require, and the following attributes: form - required, should map to Spike.Form , usually @form in assigns field - required, atom, should be one of the existing fields on the form submit_event - optional, name of an event that will be emitted when, for example, user hits Enter on the input target - optional, leave nil if your @form is handled by LiveView, set to @myself (or component selector) if the form changes should be handled by a component. import Spike.LiveView.Components ... &lt; . form_field form = { @form } field = { :first_name } &gt; &lt; input type = &quot;text&quot; name = &quot;value&quot; value = { @form_field . first_name } / &gt; &lt; / . form_field &gt;","ref":"Spike.LiveView.Components.html#form_field/1","title":"Spike.LiveView.Components.form_field/1","type":"function"},{"doc":"Spike.LiveView provides a wrapper around Phoenix.LiveView and Phoenix.LiveComponent , which simplifies working with memory-backed forms, including nested forms that require contextual validation.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding spike_liveview to your list of dependencies in mix.exs : def deps do [ { :spike_liveview , &quot;~&gt; 0.2&quot; } ] end Documentation can be found at https://hexdocs.pm/spike_liveview .","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"Once installed in a Phoenix project, open up your *_web.ex file and add the following functions: def form_live_view do quote do use Phoenix.LiveView , layout : { MyAppWeb.LayoutView , &quot;live.html&quot; } unquote ( view_helpers ( ) ) use Spike.LiveView end end def form_live_component do quote do use Phoenix.LiveComponent unquote ( view_helpers ( ) ) use Spike.LiveView end end This allows you to build LiveViews and LiveComponents that ship with form and form erors handling capabilities out of the box by defining them as follows: # for LiveView defmodule MyApp.MyFormLive do use MyAppWeb , :form_live_view def mount ( _params , _ , socket ) do form = init_form ( ) { :ok , socket |&gt; assign ( %{ form : form , errors : Spike . errors ( form ) } ) } end ... end # for LiveComponent defmodule MyApp.MyFormLiveComponent do use MyAppWeb , :form_live_view def mount ( _params , _ , socket ) do form = init_form ( ) { :ok , socket |&gt; assign ( %{ form : form , errors : Spike . errors ( form ) } ) } end For starting point to build your own form components, see our Components Library .","ref":"readme.html#quick-start","title":"Readme - Quick start","type":"extras"},{"doc":"Feel free to grab and customize these components to your needs, and treat them as a starting point when building your form builder. import Spike.LiveView.Components def errors_component ( %{ form : _ , field : _ , errors : _ } = assigns ) do ~H&quot;&quot;&quot; &lt;.errors let={field_errors} field={@field} form={@form} errors={@errors}&gt; &lt;span class=&quot;error&quot;&gt; &lt;%= field_errors |&gt; Enum.map(fn {_k, v} -&gt; v end) |&gt; Enum.join(&quot;, &quot;) %&gt; &lt;/span&gt; &lt;/.errors&gt; &quot;&quot;&quot; end def label_component ( %{ ref : _ref , text : _text , field : _field , required : required } = assigns ) do if required do ~H&quot;&quot;&quot; &lt;label for={&quot;\#{@ref}_\#{@field}&quot;}&gt;* &lt;%= @text %&gt;&lt;/label&gt; &quot;&quot;&quot; else ~H&quot;&quot;&quot; &lt;label for={&quot;\#{@ref}_\#{@field}&quot;}&gt;&lt;%= @text %&gt;&lt;/label&gt; &quot;&quot;&quot; end end def input_component ( %{ type : &quot;textarea&quot; , field : _ , form : _ , errors : _ } = assigns ) do assigns = assigns |&gt; assign_new ( :target , fn -&gt; nil end ) ~H&quot;&quot;&quot; &lt;div&gt; &lt;%= if @label do %&gt; &lt;.label_component text={@label} ref={@form.ref} field={@field} required={is_required?(@form, @field)} /&gt; &lt;% end %&gt; &lt;.form_field field={@field} form={@form} target={@target}&gt; &lt;textarea id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot;&gt;&lt;%= @form |&gt; Map.get(@field) %&gt;&lt;/textarea&gt; &lt;/.form_field&gt; &lt;.errors_component form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end def input_component ( %{ type : type , field : _ , form : _ , errors : _ } = assigns ) when type in [ &quot;text&quot; , &quot;password&quot; , &quot;email&quot; ] do assigns = assigns |&gt; assign_new ( :target , fn -&gt; nil end ) ~H&quot;&quot;&quot; &lt;div&gt; &lt;%= if @label do %&gt; &lt;.label_component text={@label} ref={@form.ref} field={@field} required={is_required?(@form, @field)} /&gt; &lt;% end %&gt; &lt;.form_field field={@field} form={@form} target={@target}&gt; &lt;input id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot; type={type} value={@form |&gt; Map.get(@field)} /&gt; &lt;/.form_field&gt; &lt;.errors_component form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end def input_component ( %{ type : &quot;checkbox&quot; , field : _ , form : _ , errors : _ } = assigns ) do assigns = assigns |&gt; assign_new ( :checked_value , fn -&gt; &quot;1&quot; end ) |&gt; assign_new ( :unchecked_value , fn -&gt; &quot;0&quot; end ) |&gt; assign_new ( :target , fn -&gt; nil end ) ~H&quot;&quot;&quot; &lt;div&gt; &lt;.form_field field={@field} form={@form} target={@target}&gt; &lt;span class=&quot;float-left&quot;&gt; &lt;input id={&quot;\#{@form.ref}_\#{@field}_unchecked&quot;} name=&quot;value&quot; type=&quot;hidden&quot; value={@unchecked_value} /&gt; &lt;input id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot; type=&quot;checkbox&quot; value={@checked_value} checked={is_checked?(@form, @field, @checked_value)} /&gt; &lt;/span&gt; &lt;span&gt; &lt;%= if @label do %&gt; &lt;.label_component text={@label} ref={@form.ref} field={@field} required={is_required?(@form, @field)} /&gt; &lt;% end %&gt; &lt;/span&gt; &lt;/.form_field&gt; &lt;.errors_component form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end def input_component ( %{ type : &quot;select&quot; , field : _ , form : _ , errors : _ , options : _ } = assigns ) do assigns = assigns |&gt; assign_new ( :target , fn -&gt; nil end ) ~H&quot;&quot;&quot; &lt;div&gt; &lt;%= if @label do %&gt; &lt;.label_component text={@label} ref={@form.ref} field={@field} required={is_required?(@form, @field)} /&gt; &lt;% end %&gt; &lt;.form_field field={@field} form={@form} target={@target}&gt; &lt;select id={&quot;\#{@form.ref}_\#{@field}&quot;} name=&quot;value&quot;&gt; &lt;%= for {value, text} &lt;- @options do %&gt; &lt;option value={value || &quot;&quot;} selected={@form |&gt; Map.get(@field) == value}&gt;&lt;%= text %&gt;&lt;/option&gt; &lt;% end %&gt; &lt;/select&gt; &lt;/.form_field&gt; &lt;.errors_component form={@form} field={@field} errors={@errors} /&gt; &lt;/div&gt; &quot;&quot;&quot; end defp is_checked? ( form , field , checked_value ) do Map . get ( form , field ) == checked_value || Map . get ( form , field ) == true end defp is_required? ( form , field ) do validations = Vex.Extract . settings ( form ) |&gt; Map . get ( field , [ ] ) { :presence , true } in validations end","ref":"components_library.html","title":"Components Library","type":"extras"}]